#
#  xhsp makefile
#

CC = gcc
CPP = g++

all:hspcmp hsplnk xhsp xhsp.hrt

hspcmp: hspcmp.cpp
	$(CPP) -O2 -o hspcmp $<

hsplnk: hsplnk.cpp
	$(CPP) -O2 -o hsplnk $<

xhsp: xhsp_dbg.o ui_cl.o
	$(CPP) -O2 -Wall -o xhsp xhsp_dbg.o ui_cl.o

xhsp.hrt: xhsp.o ui_cl.o
	$(CPP) -O2 -Wall -o xhsp.hrt xhsp.o ui_cl.o

xhsp.o: xhsp.cpp
	$(CPP) -O2 -c xhsp.cpp

xhsp_dbg.o: xhsp.cpp
	$(CPP) -O2 -c -D HSPDBG -o xhsp_dbg.o xhsp.cpp

ui_cl.o: ui_cl.cpp
	$(CPP) -O2 -c $< `gtk-config --cflags`

#hsed: hsed_gtk.cpp
#	$(CPP) -O2 -Wall -o hsed hsed_gtk.cpp `gtk-config --cflags` `gtk-config --libs`

clean:
	rm hsplnk hspcmp xhsp xhsp.hrt hsed
	rm *.o

