#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#define UNIX
#include <sys/stat.h>
#include <unistd.h>


struct DPMHEAD{
	char typ[4];
	long dummy;
	long cnt;
	long size;
}head;

struct DPMFINFO{
	char fname[16];
	long dummy[2];
	long start;
	long size;
};


int main(int argc, char *argv[], char *envp[]){
	char hsprt[512];
	char ofile[512];
	char file[16][256];
	char orgfile[64][256];
	strcpy(hsprt,"xhsp");
	strcpy(ofile,"a.exe");
	int mode=0;
	int i=1;
	int cnt=0;
	if(argc<=1){
		printf("./hsplnk -r runtime [file [file ...]]\n");
		return 0;
	}
	char *s;
	while(i<argc){
		if(argv[i][0]=='-'){
			mode=argv[i][1];
		}else{
			//printf("%s\n",argv[i]);
			switch(mode){
			case 0:
				strcpy(file[cnt],argv[i]);
				s=strchr(file[cnt],':');
				if(s && s-file[cnt]>1){
					strcpy(orgfile[cnt],s+1);
					s[0]=0;
				}else{
					strcpy(orgfile[cnt],argv[i]);
				}
				cnt++;
				break;
			case 'o':
				strcpy(ofile,argv[i]);
				mode=0;
				break;
			case 'r':
				strcpy(hsprt,argv[i]);
				mode=0;
				break;
			}
		}
		i++;
	}

	FILE *fp_r;
	FILE *fp=fopen(hsprt,"rb");
	if(fp == NULL){
		printf("hsplnk: runtime not found :%s\n",hsprt);
		return 0;
	}
	fseek(fp,0,SEEK_END); //!?
	long fsize=ftell(fp);
	fseek(fp,0,SEEK_SET);
	char *rtbuf=(char*)malloc(fsize);
	DPMFINFO *list=(DPMFINFO*)malloc(sizeof(DPMFINFO)*cnt);
	memset(list,0,sizeof(DPMFINFO)*cnt);
	fread(rtbuf,1,fsize,fp);
	fclose(fp);

	i=64;
	while(i<fsize){
		if(strcmp(rtbuf+i,"HSPHED~~")==0){
			break;
		}
		i++;
	}
	memset(rtbuf+i,0,16);
	sprintf(rtbuf+i+9,"%d",fsize-65536);

/*
	rtbuf[i+0x11]=f_full*0x66;//??
	rtbuf[i+0x13]='x';
	memcpy(rtbuf+i+0x14,wx,2);
	rtbuf[i+0x16]='x';
	memcpy(rtbuf+i+0x17,wx,2);
	rtbuf[i+0x19]=64;//??
	rtbuf[i+0x1a]=f_hide;//??
*/
	int fsz,p=0;
	i=0;
	while(i<cnt){
		strcpy(list[i].fname,file[i]);
		list[i].start=p;
		fp=fopen(orgfile[i],"rb");
		if(fp == NULL){
			printf("hspl: ERR file not found :%s\n",list[i].fname);
			exit(0);
			//i++;
		}
		fseek(fp,0,SEEK_END); //!?
		fsz=ftell(fp);
		fclose(fp);
		list[i].size=fsz;
		p+=fsz;
		i++;
	}

	fp=fopen(ofile,"wb");

	fwrite(rtbuf,1,fsize,fp);

	strcpy(head.typ,"DPM0");
	head.cnt=cnt;
	fwrite(&head,1,sizeof(DPMHEAD),fp);

	fwrite(list,1,sizeof(DPMFINFO)*cnt,fp);

	i=0;
	while(i<cnt){
		fp_r=fopen(orgfile[i],"rb");
		if(fp_r == NULL){
			printf("hspl: ERR can't open :%s\n",orgfile[i]);
			exit(0);
			//i++;
		}
		fread(rtbuf,1,list[i].size,fp_r);
		fclose(fp_r);
		fwrite(rtbuf,1,list[i].size,fp);
		printf("%s (<- %s)\n",file[i],orgfile[i]);
		i++;
	}

	fclose(fp);
	free(list);
	free(rtbuf);
#ifdef UNIX
	//umask(S_IWGRP|S_IWOTH);
	chmod(ofile,S_IRWXU|S_IRGRP|S_IXGRP|S_IROTH|S_IXOTH);
#endif
	return 0;
}
