//		GTK
//

#include <gtk/gtk.h>
//#include <gdk_imlib.h>
//#include <gdk-pixbuf/gdk-pixbuf.h>

#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include <unistd.h>
#include <time.h>
#include <sys/stat.h>

#include <stdio.h>

#include "xhsp.h"
#include "ui_gtk.h"

#define SYSFONT "-*-*-medium-r-normal-*-16-140-*-*-c-*-jisx0208.1983-0"
#define FONTSTR "-*-%s-%s-normal-*-%d-140-*-*-c-*-jisx0208.1983-0"

BMSCR *bmscr[MAXBMSCR];
int abms;

int eventflag;

gint t1;
gint break_loop(gpointer dat){
	gint t=t1;
	t1=0;
	gtk_timeout_remove(t);
	eventflag|=1;
	gtk_main_quit();
	return TRUE;
}


gint delete_event(GtkWidget *widget, GdkEvent  *event, gpointer   data ){
	//g_print ("delete event occurred\n");
	if(hsinfo.onexit){
		if(t1){
			gint t=t1;
			t1=0;
			gtk_timeout_remove(t);
		}
		eventflag|=1;
		hsinfo.pt=hsinfo.label[hsinfo.onexit];
		gtk_main_quit();
		return TRUE;
	}else{
		eventflag|=2;
		gtk_main_quit();
	}
	return FALSE;
}


static gint bms_init(GtkWidget *widget, GdkEventExpose *event){
	BMSCR *bms=bmscr[abms];
	bms->fdraw=1;
	if(bms->flag==0){
		bms->flag=1;
		bms->pix = gdk_pixmap_new(bmscr[0]->fixed->window,bms->sx,bms->sy,24);
		bms->gc=gdk_gc_new(bmscr[0]->fixed->window);
		GdkColormap *cmap=gdk_colormap_get_system();
		GdkColor c={0,0,0,0};
		gdk_color_alloc(cmap, &c);
		gdk_gc_set_foreground(bms->gc,&c);

		gdk_draw_rectangle(bms->pix,bms->fixed->style->white_gc,TRUE,
	                      0, 0,bms->sx,bms->sy);
		if(bms->fixed){
			gdk_draw_rectangle(bms->fixed->window,bms->fixed->style->white_gc,TRUE,
		                      0, 0,bms->sx,bms->sy);
			gdk_window_set_back_pixmap(bms->fixed->window,bms->pix,0);
		}
	}
	return TRUE;
}

/*
static gint bms_redraw(GtkWidget *widget, GdkEventExpose *event){

	BMSCR *bms=NULL;
	int i;
	for(i=0;i<MAXBMSCR;i++){
		if(bmscr[i] && bmscr[i]->fixed==widget){
			bms=bmscr[i];
		}
	}
	if(!bms)
		return 0;
	gdk_draw_pixmap(widget->window,
		widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
		bms->pix,
		event->area.x, event->area.y,
		event->area.x, event->area.y,
		event->area.width, event->area.height);
	 return TRUE;
}
*/

static gint bms_button(GtkWidget *widget,GdkEventButton *event, gpointer  d ){
	int k=((GdkEventKey*)event)->keyval&0xff;

	if(event->type==GDK_BUTTON_PRESS){
		sval.mbutton[event->button^(event->button>>1&1)]=1;
		if(hsinfo.onclick){
			if(t1){
				gint t=t1;
				t1=0;
				gtk_timeout_remove(t);
			}
			eventflag|=1;
			hsinfo.pt=hsinfo.label[hsinfo.onclick];
			sval.iparam=(event->button^(event->button>>1&1)) *3-3;
			sval.wparam=event->button;
			sval.lparam=(int)event->x+((int)event->y<<16);
			gtk_main_quit();
	}	}
	if(event->type==GDK_BUTTON_RELEASE){
		sval.mbutton[event->button^(event->button>>1&1)]=0;
	}
	if(event->type==GDK_KEY_PRESS){
		sval.keystat[k]=1;
		if(hsinfo.onkey){
			if(t1){
				gint t=t1;
				t1=0;
				gtk_timeout_remove(t);
			}
			eventflag|=1;
			hsinfo.pt=hsinfo.label[hsinfo.onkey];
			sval.iparam=*((unsigned short*)(((GdkEventKey*)event)->string));
			gtk_main_quit();
		}
	}
	if(event->type==GDK_KEY_RELEASE){
		sval.keystat[k]=0;
	}
	if(event->type==GDK_FOCUS_CHANGE){
		memset(sval.keystat,0,256);
	}

	return TRUE;
}

static gint object_focus(GtkWidget *widget,GdkEventFocus *event, int  id ){
	if(event->type==GDK_FOCUS_CHANGE){
		if(event->in){
			bmscr[id>>16&0xff]->selobj=id&0xff;
		}
	}
	return TRUE;
}


static void object_event(GtkWidget *widget, int id){
	//BMSCR *bms=bmscr[id>>24&0xff];
	if(bmscr[id>>16&0xff]->obj[id&0xff].style==10){//button
		if(t1){
			gint t=t1;
			t1=0;
			gtk_timeout_remove(t);
		}
		eventflag|=1;
		hsinfo.pt=bmscr[id>>16&0xff]->obj[id&0xff].dat;
		gtk_main_quit();
	}else if(bmscr[id>>16&0xff]->obj[id&0xff].style==11){//chkbox
		hsinfo.vallist[bmscr[id>>16&0xff]->obj[id&0xff].dat].pInt[0]
			=GTK_TOGGLE_BUTTON(widget)->active;
	}else if(bmscr[id>>16&0xff]->obj[id&0xff].style==12){//inout
		char *s=gtk_editable_get_chars((GtkEditable*)bmscr[id>>16&0xff]->obj[id&0xff].wnd,
			0,-1);
		strcpy((char*)bmscr[id>>16&0xff]->obj[id&0xff].dat,s);
		g_free(s);
	}else if(bmscr[id>>16&0xff]->obj[id&0xff].style==13){//listbox
		*((int*)bmscr[id>>16&0xff]->obj[id&0xff].dat)=
			gtk_list_child_position((GtkList*)widget->parent,widget);
	}
}

int KEventChk(){
	while(gtk_events_pending()){
		if(gtk_main_iteration_do(FALSE)==0){
			exit(0);
		}
	}
	return 0;
}

int WaitInitBMS(BMSCR *bms){
	while(bms->gc==NULL){
		while(gtk_events_pending()){
			if(gtk_main_iteration_do(FALSE)==0){
				exit(0);
			}
		}
		usleep(1000);
	}
	return 0;
}

void HSP_InitBMS(BMSCR *bms,int sx,int sy,int flag)
{
	memset(bms,0,sizeof(BMSCR));
	bms->sx=sx;
	bms->sy=sy;
	bms->curx=0;
	bms->cury=0;
	bms->objw=64;
	bms->objh=24;
	//bms->objs=0;

	bms->gc=NULL;
	//	window
	bms->wnd=gtk_window_new((flag&1024)?GTK_WINDOW_POPUP:GTK_WINDOW_TOPLEVEL);
	gtk_window_set_policy(GTK_WINDOW(bms->wnd), FALSE, FALSE, TRUE);
	gtk_widget_set_events(bms->wnd,
		GDK_KEY_PRESS_MASK|GDK_KEY_RELEASE_MASK);
	gtk_signal_connect(GTK_OBJECT(bms->wnd), "destroy",
			GTK_SIGNAL_FUNC(gtk_main_quit), NULL);
	gtk_signal_connect(GTK_OBJECT(bms->wnd), "delete_event",
			GTK_SIGNAL_FUNC(delete_event), NULL);//gtk_main_quit
	gtk_signal_connect(GTK_OBJECT(bms->wnd),"configure_event",
			(GtkSignalFunc)bms_init, NULL);
	gtk_signal_connect(GTK_OBJECT(bms->wnd),"key_press_event",
			GTK_SIGNAL_FUNC(bms_button), NULL);
	gtk_signal_connect(GTK_OBJECT(bms->wnd),"key_release_event",
			GTK_SIGNAL_FUNC(bms_button), NULL);
	gtk_signal_connect(GTK_OBJECT(bms->wnd),"focus_out_event",
			GTK_SIGNAL_FUNC(bms_button), NULL);


	//	fixed
	bms->fixed = gtk_fixed_new();
	gtk_widget_set_usize(bms->fixed,sx,sy);
	gtk_widget_set_events(bms->fixed,
		GDK_EXPOSURE_MASK|GDK_BUTTON_PRESS_MASK|GDK_BUTTON_RELEASE_MASK);
//	gtk_signal_connect(GTK_OBJECT(bms->fixed),"configure_event",
//			(GtkSignalFunc)bms_init, NULL);
//	gtk_signal_connect(GTK_OBJECT(bms->fixed),"expose_event",
//			(GtkSignalFunc)bms_redraw, NULL);
	gtk_signal_connect(GTK_OBJECT(bms->fixed),"button_press_event",
			GTK_SIGNAL_FUNC(bms_button), NULL);
	gtk_signal_connect(GTK_OBJECT(bms->fixed),"button_release_event",
			GTK_SIGNAL_FUNC(bms_button), NULL);
	gtk_container_add(GTK_CONTAINER(bms->wnd),bms->fixed);

	gtk_widget_show(bms->fixed);


	//	iroiro

	bms->fs=16;
	bms->font = gdk_fontset_load (SYSFONT);

}

void HSP_InitBMS2(BMSCR *bms,int sx,int sy,int flag)
{
	memset(bms,0,sizeof(BMSCR));
	bms->sx=sx;
	bms->sy=sy;
	bms->curx=0;
	bms->cury=0;
	bms->objw=64;
	bms->objh=24;
	bms->fdraw=0;
	//bms->objs=0;

	bms->flag=1;
	bms->pix = gdk_pixmap_new(bmscr[0]->fixed->window,bms->sx,bms->sy,24);
	bms->gc=gdk_gc_new(bmscr[0]->fixed->window);
	GdkColormap *cmap=gdk_colormap_get_system();
	GdkColor c={0,0,0,0};
	gdk_color_alloc(cmap, &c);
	gdk_gc_set_foreground(bms->gc,&c);

	gdk_draw_rectangle(bms->pix,bmscr[0]->fixed->style->white_gc,TRUE,
		0, 0,bms->sx,bms->sy);

	//	window
	bms->wnd=NULL;
	bms->fixed = NULL;

	//	font

	bms->fs=16;
	bms->font = gdk_fontset_load (SYSFONT);
}


void HSP_FreeBMS(BMSCR *bms){
	int id;
	for(id=0;id<objkazz;id++){
		if(bms->obj[id].wnd){
			gtk_widget_destroy(bms->obj[id].wnd);
			bms->obj[id].wnd=NULL;
		}
	}
	gdk_pixmap_unref(bms->pix);
	if(bms->wnd)gtk_widget_unmap(bms->wnd);
}

void gtk_sleep(int w){
	t1=gtk_timeout_add(w,break_loop,0);
	gtk_main();
//	KEventChk();
}


////////////////////////////////////////////////////////////////////////
//		GUIѴؿ

int excmd_init(int argc, char *argv[], char *envp[])
{
	gtk_set_locale();
	gtk_init(&argc, &argv);
	//gdk_rgb_init();

	// ꡼0 
	abms=0;
	bmscr[0]=(BMSCR*)malloc(sizeof(BMSCR));
	HSP_InitBMS(bmscr[0],640,480,0);
	gtk_widget_show(bmscr[0]->wnd);
	WaitInitBMS(bmscr[0]);
//	gtk_sleep(10);

	return 0;
}

////////////////////////////////////////////////////////////////////////
//		GUIѴؿλ

int excmd_end(){
	int i;
	// BMS
	for(i=0;i<MAXBMSCR;i++){
		if(bmscr[i]){
			HSP_FreeBMS(bmscr[i]);
			free(bmscr[i]);
			bmscr[i]=NULL;
		}
	}
	return 0;
}


////////////////////////////////////////////////////////////////////////
//		HSPؿ (GUI@gtk+)


static timeval await_time;

int hs_wait(){
	t1=gtk_timeout_add(prmm[0].i*10,break_loop,0);
	eventflag&=0xfe;
	gtk_main();
	if(eventflag!=1){printf("halted\n");exit(0);}
	gettimeofday(&await_time,NULL);
	return 0;
}

int hs_await(){
	int w;
	timeval t;
	gettimeofday(&t,NULL);
	w = prmm[0].i-(t.tv_sec-await_time.tv_sec)*1000-(t.tv_usec-await_time.tv_usec)/1000;
	if(w<0) w=0;
	t1=gtk_timeout_add(w,break_loop,0);
	eventflag&=0xfe;
	gtk_main();
	if(eventflag!=1){printf("halted\n");exit(0);}
	if(w){
		await_time.tv_sec += prmm[0].i/1000;
		await_time.tv_usec += (prmm[0].i%1000)*1000;
	}else{
		gettimeofday(&await_time,NULL);
 }

	return 0;
}

int hs_stop(){
	eventflag&=0xfe;
	gtk_main ();
	if(eventflag!=1){printf("halted\n");exit(0);}
	gettimeofday(&await_time,NULL);
	return 0;
}


int hs_getkey(){
	int k=prmm[1].i;
	if(prmm[1].i<=3){
		prmm[0].pInt[0]=sval.mbutton[k];
		return 0;
	}
	if(prms>2)
		k=0;

	// X to Win32
	if(k==16){ //SHIFT
		prmm[0].pInt[0]=sval.keystat[225] | sval.keystat[226];
	}else if (k==17){ //CTRL
		prmm[0].pInt[0]=sval.keystat[227] | sval.keystat[228];
	}else if (k==18){ //ALT
		prmm[0].pInt[0]=sval.keystat[233] | sval.keystat[234];
	}else if (k==20){ //CAPS LOCK
		prmm[0].pInt[0]=sval.keystat[229];
	}else if (k>=33 & k<=35){ // PgUP PgDn End
		prmm[0].pInt[0]=sval.keystat[k+52];
	}else if (k>=36 & k<=40){ //Home L U R D
		prmm[0].pInt[0]=sval.keystat[k+44];
	}else if (k==45){ //Ins
		prmm[0].pInt[0]=sval.keystat[99];
	}else if (k==46){ //Del
		prmm[0].pInt[0]=sval.keystat[255];
	}else if (k==29){ //̵Ѵ
		prmm[0].pInt[0]=sval.keystat[34];
	}else if (k>=65 & k<=90){ //A-Z
		prmm[0].pInt[0]=sval.keystat[k] | sval.keystat[k+32];
	}else if (k>=96 & k<=105){ //0-9(Tenkey)
		prmm[0].pInt[0]=sval.keystat[k+80];
	}else if (k>=106 & k<=111){ // * + , - . /
		prmm[0].pInt[0]=sval.keystat[k+64];
	}else if (k>=112 & k<=126){ // F1-
		prmm[0].pInt[0]=sval.keystat[k+78];
	}else if (k>=186 & k<=187){ // : ;
		prmm[0].pInt[0]=sval.keystat[k-128];
	}else if (k>=188 & k<=191){ // ,-./
		prmm[0].pInt[0]=sval.keystat[k-144];
	}else if (k==192){ // @
		prmm[0].pInt[0]=sval.keystat[k-128];
	}else if (k>=219 & k<=223){ // ,-./
		prmm[0].pInt[0]=sval.keystat[k-128];
	}else{
		prmm[0].pInt[0]=sval.keystat[prmm[1].i];
	}
	return 0;
}


int hs_stick(){
	prmm[0].pInt[0]=sval.keystat[81]
		+(sval.keystat[82]<<1)
		+(sval.keystat[83]<<2)
		+(sval.keystat[84]<<3)
		+(sval.keystat[32]<<4)
		+(sval.keystat[13]<<5)
		+(sval.keystat[227]<<6)
		+(sval.keystat[27]<<7)
		+(sval.keystat[1]<<8)
		+(sval.keystat[2]<<9)
		+(sval.keystat[9]<<10);
	return 0;
}


int hs_font(){
	char name[256];
	char *typ[]={"medium-r","bold-r","medium-i","bold-i"};
	if(prms<3) prmm[2].i=0;
	if(prms<2) prmm[2].i=16;
	sprintf(name,FONTSTR,prmm[0].s,typ[prmm[2].i &3 ],prmm[1].i);
	GdkFont* font = gdk_fontset_load (name);
	if(font){
		// change font
		gdk_font_unref(bmscr[abms]->font);
		bmscr[abms]->font = font;
		bmscr[abms]->fs=prmm[1].i;
	}
	return 0;
}

int hs_sysfont(){
	GdkFont* font = gdk_fontset_load(SYSFONT);
	if(font){
		// change font
		gdk_font_unref(bmscr[abms]->font);
		bmscr[abms]->font = font;
		bmscr[abms]->fs=16;
	}
	return 0;
}

int hs_mes(){
	BMSCR* bms=bmscr[abms];
	if(prmm[0].type!=2){
		sprintf(prmm[0].s,"%d",prmm[0].i);
	}
	int i=0,p=0,c;
	do{
		if(prmm[0].s[i]==10 || prmm[0].s[i]==0){
			c=prmm[0].s[i];
			prmm[0].s[i]=0;
			gdk_draw_string(bms->pix,bms->font,bms->gc,
					bms->curx, bms->cury+bmscr[abms]->fs-1,prmm[0].s+p);
			if(bmscr[abms]->fdraw)
				gdk_draw_string(bms->fixed->window,bms->font,bms->gc,
					bms->curx, bms->cury+bmscr[abms]->fs-1,prmm[0].s+p);
			bms->cury+=bmscr[abms]->fs;
			prmm[0].s[i]=c;
			p=i+1;
		}
	}while(prmm[0].s[i++]);
//	gdk_draw_string(bms->pix,bms->font,bms->gc,
//			bms->curx, bms->cury+bmscr[abms]->fs,prmm[0].s);
//	if(bmscr[abms]->fdraw)
//	gdk_draw_string(bms->fixed->window,bms->font,bms->gc,
//			bms->curx, bms->cury+bmscr[abms]->fs,prmm[0].s);
//	if(prmm[1].type!=1){
//		bms->cury+=bmscr[abms]->fs;
//	}
	return 0;
}

int hs_pos(){
	bmscr[abms]->curx=prmm[0].i;
	if(prms>1)bmscr[abms]->cury=prmm[1].i;
	return 0;
}

int hs_color(){
	GdkColormap *cmap=gdk_colormap_get_system();
	GdkColor c={0,prmm[0].i*257,prmm[1].i*257,prmm[2].i*257};
	gdk_color_alloc(cmap, &c);
	gdk_gc_set_foreground(bmscr[abms]->gc,&c);
	return 0;
}

int hs_pset(){
	if(prms<2){
		prmm[0].i=bmscr[abms]->curx;
		prmm[1].i=bmscr[abms]->cury;
	}
	gdk_draw_point(bmscr[abms]->pix,bmscr[abms]->gc,
			 prmm[0].i,prmm[1].i);
	if(bmscr[abms]->fdraw)
	gdk_draw_point(bmscr[abms]->fixed->window,bmscr[abms]->gc,
			 prmm[0].i,prmm[1].i);
	return 0;
}
/*
int hs_pset(){
	if(prms>0){
		bmscr[abms]->curx=prmm[0].i;
		bmscr[abms]->cury=prmm[1].i;
	}
	gdk_draw_point(bmscr[abms]->pix,bmscr[abms]->gc,
			 bmscr[abms]->curx, bmscr[abms]->cury);
	if(bmscr[abms]->fdraw)
	gdk_draw_point(bmscr[abms]->fixed->window,bmscr[abms]->gc,
			 bmscr[abms]->curx, bmscr[abms]->cury);
	return 0;
}
*/

int hs_pget(){
	//XShmCreateImageȤ٤...
	if(prmm[0].i<0 || prmm[0].i>bmscr[abms]->sx ||
		prmm[1].i<0 || prmm[1].i>bmscr[abms]->sy){return 0;}
	GdkImage *img=gdk_image_get(bmscr[abms]->pix, prmm[0].i,prmm[1].i, 1,1);

	sval.bval=((unsigned char*)img->mem)[0];
	sval.gval=((unsigned char*)img->mem)[1];
	sval.rval=((unsigned char*)img->mem)[2];

	gdk_image_destroy(img);
	return 0;
}

int hs_line(){
	if(prms>2){
		bmscr[abms]->curx=prmm[2].i;
		bmscr[abms]->cury=prmm[3].i;
	}
	gdk_draw_line(bmscr[abms]->pix,bmscr[abms]->gc,
			bmscr[abms]->curx,bmscr[abms]->cury, prmm[0].i, prmm[1].i);

	if(bmscr[abms]->fdraw)
	gdk_draw_line(bmscr[abms]->fixed->window,bmscr[abms]->gc,
			bmscr[abms]->curx,bmscr[abms]->cury, prmm[0].i, prmm[1].i);
	bmscr[abms]->curx=prmm[0].i;
	bmscr[abms]->cury=prmm[1].i;
	return 0;
}

int hs_boxf(){
	if(prms<3){
		prmm[2].i=bmscr[abms]->sx;
		prmm[3].i=bmscr[abms]->sy;
	}
	gdk_draw_rectangle (bmscr[abms]->pix,
			bmscr[abms]->gc,TRUE,
			prmm[0].i, prmm[1].i,
			prmm[2].i-prmm[0].i+1, prmm[3].i- prmm[1].i+1);

	if(bmscr[abms]->fdraw)
	gdk_draw_rectangle (bmscr[abms]->fixed->window,
			bmscr[abms]->gc,TRUE,
			prmm[0].i, prmm[1].i,
			prmm[2].i-prmm[0].i+1, prmm[3].i- prmm[1].i+1);
	return 0;
}

int hs_gcopy(){
	if(prms<5){
		prmm[3].i=bmscr[abms]->gm_w;
		prmm[4].i=bmscr[abms]->gm_h;
	}
	gdk_draw_pixmap(bmscr[abms]->pix,bmscr[abms]->gc,bmscr[prmm[0].i]->pix,
		prmm[1].i,prmm[2].i,bmscr[abms]->curx,bmscr[abms]->cury,prmm[3].i,prmm[4].i);
	if(bmscr[abms]->fdraw)
	gdk_draw_pixmap(bmscr[abms]->fixed->window,bmscr[abms]->gc,bmscr[prmm[0].i]->pix,
		prmm[1].i,prmm[2].i,bmscr[abms]->curx,bmscr[abms]->cury,prmm[3].i,prmm[4].i);
	return 0;
}

struct BITMAP{
	int sx;
	int sy;
	int bpp;
	int aline;
	unsigned char *pBit;
};

//
// StretchBltɤ
//	aline=(sx*(d>>3)+3)&~3;

void line_stretch(unsigned char *dst,int dx,unsigned char *src,int sx, int bpp)
{
	int x1=0;
	int x2=0;
	while(x1<dx){
		dst[0]=src[0];
		dst[1]=src[1];
		dst[2]=src[2];
		dst+=bpp;
		x1++;
		if(x1*sx>=(x2+1)*dx){
			src+=bpp;
			x2++;
		}
	}
}
void line_shorten(unsigned char *dst,int dx,unsigned char *src,int sx, int bpp)
{
	int x1=0;
	int x2=0;
	while(x1<dx){
		if(x2*dx>=(x1)*sx){
			dst[0]=src[0];
			dst[1]=src[1];
			dst[2]=src[2];
			dst+=bpp;
			x1++;
		}
		src+=bpp;
		x2++;
	}
}
int stretch(BITMAP* dst, int dx,int dy, int dw,int dh,
			BITMAP* src, int sx,int sy, int sw,int sh)
{
	unsigned char* dp=dst->pBit+dy*dst->aline + dx*dst->bpp;
	unsigned char* sp=src->pBit+sy*src->aline + sx*src->bpp;
	int y1=0;
	int y2=0;
	if(dh>sh){
		if(dw>sw){
			while(y1<dh){
				line_stretch(dp,dw,sp,sw,src->bpp);
				dp+=dst->aline;
				y1++;
				if(y1*sh>=(y2+1)*dh){
					sp+=src->aline;
					y2++;
				}
			}
		}else{
			while(y1<dh){
				line_shorten(dp,dw,sp,sw,src->bpp);
				dp+=dst->aline;
				y1++;
				if(y1*sh>=(y2+1)*dh){
					sp+=src->aline;
					y2++;
				}
			}
		}
	}else{
		if(dw>sw){
			while(y1<dh){
				if(y2*dh>=(y1)*sh){
					line_stretch(dp,dw,sp,sw,src->bpp);
					dp+=dst->aline;
					y1++;
				}
				sp+=src->aline;
				y2++;
			}
		}else{
			while(y1<dh){
				if(y2*dh>=(y1)*sh){
					line_shorten(dp,dw,sp,sw,src->bpp);
					dp+=dst->aline;
					y1++;
				}
				sp+=src->aline;
				y2++;
			}
		}
	}
	return 0;
}


int hs_gzoom(){
	if(prms<7){
		prmm[5].i=bmscr[abms]->gm_w;
		prmm[6].i=bmscr[abms]->gm_h;
	}
	GdkImage *img=gdk_image_get(bmscr[prmm[2].i]->pix, prmm[3].i,prmm[4].i, prmm[5].i,prmm[6].i);
	GdkImage *img2=gdk_image_new(GDK_IMAGE_FASTEST,gdk_visual_get_best_with_depth(img->depth),prmm[0].i,prmm[1].i+32);
	BITMAP Bmp1;
	BITMAP Bmp2;
	Bmp1.sx = prmm[5].i;
	Bmp1.sy = prmm[6].i;
	Bmp1.bpp = img->bpp>>3; // bug?
	Bmp1.aline = img->bpl;
	Bmp1.pBit = (unsigned char*)img->mem;

	Bmp2.sx = prmm[0].i;
	Bmp2.sy = prmm[1].i;
	Bmp2.bpp = img2->bpp;
	Bmp2.aline = img2->bpl;
	Bmp2.pBit = (unsigned char*)img2->mem;

	stretch( &Bmp2, 0,0, prmm[0].i,prmm[1].i,
		 &Bmp1, 0,0, prmm[5].i,prmm[6].i );

	gdk_draw_image(bmscr[abms]->pix,bmscr[abms]->gc,img2,0,0,
		bmscr[abms]->curx,bmscr[abms]->cury, prmm[0].i,prmm[1].i);
	//gdk_draw_rgb_image(bmscr[abms]->pix,bmscr[abms]->gc, bmscr[abms]->curx,bmscr[abms]->cury, prmm[0].i,prmm[1].i,
	//		GDK_RGB_DITHER_NONE, Bmp2.pBit, Bmp2.aline);
	gdk_image_destroy(img);
	gdk_image_destroy(img2);

	if(bmscr[abms]->fdraw)
	gdk_draw_pixmap(bmscr[abms]->fixed->window,bmscr[abms]->gc,bmscr[abms]->pix,
		bmscr[abms]->curx,bmscr[abms]->cury,bmscr[abms]->curx,bmscr[abms]->cury,prmm[0].i,prmm[1].i);

	return 0;
}

/*
int hs_gzoom2(){
	if(prms<7){
		prmm[5].i=bmscr[abms]->gm_w;
		prmm[6].i=bmscr[abms]->gm_h;
	}
	// make pixbuf
	GdkColormap *cmap = gdk_window_get_colormap(bmscr[0]->wnd->window);
	GdkPixbuf* pbuf = gdk_pixbuf_get_from_drawable(NULL,bmscr[prmm[2].i]->pix,
					cmap,
					prmm[3].i,prmm[4].i,
					0,0, //dstx,dsty
					prmm[5].i,prmm[6].i); // w,h

	GdkPixbuf* pbuf2= gdk_pixbuf_scale_simple(pbuf,prmm[0].i,prmm[1].i,GDK_INTERP_NEAREST);
	if(pbuf2==0)exit(0);
	gdk_pixbuf_render_to_drawable(pbuf2,bmscr[abms]->pix,
					bmscr[abms]->gc,
					0,0,   // srcx,srcy
					bmscr[abms]->curx,bmscr[abms]->cury,
					prmm[0].i,prmm[1].i,
					GDK_RGB_DITHER_NONE,0,0);

	if(bmscr[abms]->fdraw)
	gdk_draw_pixmap(bmscr[abms]->fixed->window,bmscr[abms]->gc,bmscr[abms]->pix,
		bmscr[abms]->curx,bmscr[abms]->cury,bmscr[abms]->curx,bmscr[abms]->cury,prmm[0].i,prmm[1].i);

	gdk_pixbuf_unref(pbuf);
	gdk_pixbuf_unref(pbuf2);
	return 0;
}
*/

int hs_gmode(){
	bmscr[abms]->gm_m=prmm[0].i;
	bmscr[abms]->gm_w=prmm[1].i;
	bmscr[abms]->gm_h=prmm[2].i;
	return 0;
}

// BITMAP
typedef struct tBMPFILEHEADER {
	//short bfType;
	long  bfSize;
	short bfReserved1;
	short bfReserved2;
	long  bfOffBits;
} BMPFILEHEADER;

typedef struct tBMPINFOHEADER{
   long  biSize;
   long  biWidth;
   long  biHeight;
   short biPlanes;
   short biBitCount;
   long  biCompression;
   long  biSizeImage;
   long  biXPelsPerMeter;
   long  biYPelsPerMeter;
   long  biClrUsed;
   long  biClrImportant;
} BMPINFOHEADER;

int hs_bmpsave(){
	if(prmm[0].type!=0x2) return 6;
	FILE *fp=fopen(prmm[0].s,"wb");
	if(fp == NULL)
		return 12;
	fwrite("BM",1,2,fp);
	BMPFILEHEADER bfhead;
	BMPINFOHEADER bihead;
	memset(&bfhead,0,sizeof(BMPFILEHEADER));
	memset(&bihead,0,sizeof(BMPINFOHEADER));
	bihead.biSize=sizeof(BMPINFOHEADER);
	bihead.biWidth=bmscr[abms]->sx;
	bihead.biHeight=bmscr[abms]->sy;
	bihead.biPlanes=1;
	bihead.biBitCount=24;
	bihead.biSizeImage=bmscr[abms]->sx*bmscr[abms]->sy*3;

	bfhead.bfOffBits=2+sizeof(BMPFILEHEADER)+sizeof(BMPINFOHEADER);
	bfhead.bfSize=bfhead.bfOffBits+bihead.biSizeImage;

	fwrite(&bfhead,1,sizeof(BMPFILEHEADER),fp);
	fwrite(&bihead,1,sizeof(BMPINFOHEADER),fp);

	char *buf=(char*)malloc(bihead.biSizeImage+16);

	GdkImage *img=gdk_image_get(bmscr[abms]->pix, 0,0, bmscr[abms]->sx,bmscr[abms]->sy);
	img->bpp>>=3; // bug?
	int x,y;
	char* p=buf;
	char* p2=(char *)img->mem+img->bpl*(bmscr[abms]->sy-1);
	for(y=0;y<bmscr[abms]->sy;y++){
		for(x=0;x<bmscr[abms]->sx;x++){
			*(int*)p=*(int*)(p2+img->bpp*x);
			p+=3;
		}
		p2-=img->bpl;
	}

	gdk_image_destroy(img);


	fwrite(buf,1,bihead.biSizeImage,fp);
	free(buf);

	fclose(fp);
	return 0;
}

int hs_redraw(){
	if(!bmscr[abms]->fixed)
		return 99;
	if(prmm[0].i&1 || prms==0){
		if(prms<3){
			prmm[1].i=0;
			prmm[2].i=0;
		}
		if(prms<5){
			prmm[3].i=bmscr[abms]->sx;
			prmm[4].i=bmscr[abms]->sy;
		}
		gdk_draw_pixmap(bmscr[abms]->fixed->window,bmscr[abms]->gc,bmscr[abms]->pix,
			prmm[1].i,prmm[2].i,prmm[1].i,prmm[2].i,prmm[3].i,prmm[4].i);
		bmscr[abms]->fdraw=1;
	}else{
		bmscr[abms]->fdraw=0;
	}
	return 0;
}


int bmp_size(char *buf,int *w,int*h)
{
	if(memcmp(buf,"BM",2)) return 0;
	BMPFILEHEADER *bfhead=(BMPFILEHEADER*)(buf+2);
	BMPINFOHEADER *bihead=(BMPINFOHEADER*)(buf+14);
	*w=bihead->biWidth;
	*h=bihead->biHeight;
	return 1;
}
int bmp_draw(BMSCR *bms,char* buf,int size,int px,int py)
{
	if(memcmp(buf,"BM",2)) return 0;
	BMPFILEHEADER *bfhead=(BMPFILEHEADER*)(buf+2);
	BMPINFOHEADER *bihead=(BMPINFOHEADER*)(buf+14);
	unsigned char* p=(unsigned char*)buf+bfhead->bfOffBits;

	GdkImage *img=gdk_image_new(GDK_IMAGE_FASTEST,gdk_visual_get_best_with_depth(24),bihead->biWidth,bihead->biHeight);
	int x,y;
	unsigned char* p2=(unsigned char *)img->mem+img->bpl*(bihead->biHeight-1);
	if(bihead->biBitCount==24){
		for(y=0;y<bihead->biHeight;y++){
			for(x=0;x<bihead->biWidth;x++){
				*(int*)p2=*(int*)p;
				//p2[0]=p[0];
				//p2[1]=p[1];
				//p2[2]=p[2];
				p+=3;
				p2+=img->bpp;
			}
			p2-=img->bpl*2;
		}
	}else{
		unsigned char *pals=(unsigned char*)bihead + sizeof(BMPINFOHEADER);
		int bmask=(1<<bihead->biBitCount)-1;
		int c,b=0;
		for(y=0;y<bihead->biHeight;y++){
			for(x=0;x<bihead->biWidth;x++){
				if(b==0){
					c=*p;
					p++;
					b=8;
				}
				b-=bihead->biBitCount;
				*(int*)p2=((int*)pals)[(c>>b)&bmask];
			//	p2[0]=pals[((c>>b)&bmask)*4];
			//	p2[1]=pals[((c>>b)&bmask)*4+1];
			//	p2[2]=pals[((c>>b)&bmask)*4+2];
				p2+=img->bpp;
			}
			p2-=img->bpl*2;
		}
	}

	gdk_draw_image(bms->pix,bms->gc,img,0,0,
		px,py, bihead->biWidth,bihead->biHeight);

	gdk_image_destroy(img);
	return 1;
}


int hs_picload(){

	int w,h;
	int size=dpm_exist(prmm[0].s);
	if(size<0) return 12; // FILE not found
	char *buf=(char*)malloc(size+64);
	dpm_load(buf,size,prmm[0].s,0);
	if(bmp_size(buf,&w,&h)){
		// windows bitmap file
		if(prmm[1].i==0){
			if(bmscr[abms]->wnd==NULL && bmscr[abms]->pix!=NULL){
				HSP_FreeBMS(bmscr[abms]);
				HSP_InitBMS2(bmscr[abms],w,h,0);
			}else{
				HSP_FreeBMS(bmscr[abms]);
				HSP_InitBMS(bmscr[abms],w,h,0);
				gtk_widget_show(bmscr[abms]->wnd);
				WaitInitBMS(bmscr[abms]);
				//t1=gtk_timeout_add(200,break_loop,0);
				//gtk_main();
			}
		}
		bmp_draw(bmscr[abms],buf,size,prmm[2].i,prmm[3].i);
	}else{

		GdkPixmap* pixmap = gdk_pixmap_create_from_xpm(bmscr[abms]->wnd->window, NULL,
					NULL,
					prmm[0].s);
		gdk_window_get_size(pixmap,&w,&h);
		if(prmm[1].i==0){
			HSP_FreeBMS(bmscr[abms]);
			HSP_InitBMS(bmscr[abms],w,h,0);
			//if(prmm[3].type!=1 || (prmm[3].i&2)==0){
				gtk_widget_show(bmscr[abms]->wnd);
			//}
			t1=gtk_timeout_add(200,break_loop,0);
			gtk_main();
			//KEventChk();
		}
		gdk_draw_pixmap(bmscr[abms]->pix,bmscr[abms]->gc,pixmap,0,0,
			prmm[2].i,prmm[3].i,w,h);
		gdk_pixmap_unref(pixmap);
	}
	free(buf);

	if(bmscr[abms]->fdraw)
		gdk_draw_pixmap(bmscr[abms]->fixed->window,bmscr[abms]->gc,bmscr[abms]->pix,prmm[2].i,prmm[3].i,
			prmm[2].i,prmm[3].i,w,h);
	//	gdk_draw_pixmap(bmscr[abms]->fixed->window,bmscr[abms]->gc,pixmap,0,0,
	//		bmscr[abms]->curx,bmscr[abms]->cury,w,h);
	return 0;
}

int hs_cls(){
	GdkGC *bg=bmscr[0]->fixed->style->white_gc;
	if(prms>0 && prmm[0].i==4){
		bg=bmscr[0]->fixed->style->black_gc;
	}
	gdk_draw_rectangle (bmscr[abms]->pix,bg,TRUE,
				0, 0,bmscr[abms]->sx,bmscr[abms]->sy);
	//bmscr[abms]->wnd->allocation.width,bmscr[abms]->wnd->allocation.height);

	if(bmscr[abms]->fdraw){
		gdk_draw_rectangle (bmscr[abms]->fixed->window,bg,TRUE,
	                      0, 0,bmscr[abms]->sx,bmscr[abms]->sy);
	}
	int id;
	for(id=0;id<objkazz;id++){
		if(bmscr[abms]->obj[id].wnd){
			gtk_widget_destroy(bmscr[abms]->obj[id].wnd);
			bmscr[abms]->obj[id].wnd=NULL;
		}
	}
	//bmscr[abms]->objs=0;
	bmscr[abms]->curx=0;
	bmscr[abms]->cury=0;
	prmm[0].i=0;
	prmm[1].i=0;
	prmm[2].i=0;
	hs_color();
	return 0;
}

int hs_width(){
	gtk_widget_set_usize(bmscr[abms]->wnd,prmm[0].i,prmm[1].i);
	if(prms>=4){
		gtk_widget_set_uposition(bmscr[abms]->wnd,prmm[2].i,prmm[3].i);
	}
	return 0;
}

int hs_title(){
	gtk_window_set_title(GTK_WINDOW(bmscr[abms]->wnd),prmm[0].s);
	return 0;
}

int hs_objsize(){
	bmscr[abms]->objw=prmm[0].i;
	if(prms>1)bmscr[abms]->objh=prmm[1].i;
	return 0;
}

int hs_objsel(){
	if(prmm[0].i<0)
		sval.stat=bmscr[abms]->selobj;
	else
		gtk_window_set_focus(GTK_WINDOW(bmscr[abms]->wnd),bmscr[abms]->obj[prmm[0].i].wnd);
	return 0;
}


int find_nullobj(){
	int i;
	for(i=0;i<objkazz;i++){
		if(bmscr[abms]->obj[i].wnd == NULL){
			return i;
		}
	}
	return -1;
}

int hs_objprm(){
	OBJ* obj=&bmscr[abms]->obj[prmm[0].i];
	int i=0;
	switch(obj->style){
	case 10:
		gtk_label_set_text(GTK_LABEL(GTK_BUTTON(obj->wnd)->child),prmm[1].s);
		break;
	case 11:
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(obj->wnd),prmm[1].i);
		break;
	case 12:
		gtk_editable_delete_text(GTK_EDITABLE(obj->wnd),0,-1);
		gtk_editable_insert_text(GTK_EDITABLE(obj->wnd),
			prmm[1].s,strlen(prmm[1].s),&i);
		//gtk_entry_set_text(GTK_ENTRY(obj->wnd),prmm[1].s);
		break;
	case 13:
		gtk_editable_delete_text(GTK_EDITABLE(obj->wnd),0,-1);
		gtk_editable_insert_text(GTK_EDITABLE(obj->wnd),
			prmm[1].s,strlen(prmm[1].s),&i);
		//gtk_entry_set_text(GTK_ENTRY(obj->wnd),prmm[1].s);
		break;
	}
	return 0;
}
int hs_clrobj(){
	int id;
	int st=0,ed=objkazz;
	if(prmm[0].type==1 && prmm[0].i>=0){
		st=prmm[0].i;
	}
	if(prmm[1].type==1 && prmm[1].i<objkazz){
		ed=prmm[1].i+1;
	}
	for(id=st;id<ed;id++){
		if(bmscr[abms]->obj[id].wnd){
			gtk_widget_destroy(bmscr[abms]->obj[id].wnd);
			bmscr[abms]->obj[id].wnd=NULL;
		}
	}
	return 0;
}

int hs_button(){
	int id=find_nullobj();
	sval.stat=id;
	if(id<0)
		return 0;
	bmscr[abms]->obj[id].dat = hsinfo.label[prmm[1].i];
	bmscr[abms]->obj[id].style = 10;
	bmscr[abms]->obj[id].wnd = gtk_button_new_with_label(prmm[0].s);
	gtk_widget_set_usize(bmscr[abms]->obj[id].wnd,bmscr[abms]->objw,bmscr[abms]->objh);

	gtk_signal_connect(GTK_OBJECT(bmscr[abms]->obj[id].wnd),"clicked",
			GTK_SIGNAL_FUNC(object_event),(gpointer)(id+(abms<<16)));
	gtk_signal_connect(GTK_OBJECT(bmscr[abms]->obj[id].wnd),"focus_in_event",
			GTK_SIGNAL_FUNC(object_focus),(gpointer)(id+(abms<<16)));

	gtk_fixed_put(GTK_FIXED (bmscr[abms]->fixed),bmscr[abms]->obj[id].wnd,
		bmscr[abms]->curx, bmscr[abms]->cury);
	gtk_widget_show(bmscr[abms]->obj[id].wnd);
	bmscr[abms]->cury+=bmscr[abms]->objh;

	//bmscr[abms]->objs++;
	return 0;
}

int hs_chkbox(){
	int id=find_nullobj();
	sval.stat=id;
	if(id<0)
		return 0;
	bmscr[abms]->obj[id].dat = prmm[1].i;
	bmscr[abms]->obj[id].style = 11;
	bmscr[abms]->obj[id].wnd = gtk_check_button_new_with_label(prmm[0].s);
	gtk_widget_set_usize(bmscr[abms]->obj[id].wnd,bmscr[abms]->objw,bmscr[abms]->objh);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(bmscr[abms]->obj[id].wnd), hsinfo.vallist[prmm[1].i].pInt[0]);

	gtk_signal_connect(GTK_OBJECT(bmscr[abms]->obj[id].wnd),"toggled",
			GTK_SIGNAL_FUNC(object_event),(gpointer)(id+(abms<<16)));
	gtk_signal_connect(GTK_OBJECT(bmscr[abms]->obj[id].wnd),"focus_in_event",
			GTK_SIGNAL_FUNC(object_focus),(gpointer)(id+(abms<<16)));

	gtk_fixed_put(GTK_FIXED (bmscr[abms]->fixed),bmscr[abms]->obj[id].wnd,
		bmscr[abms]->curx, bmscr[abms]->cury);
	gtk_widget_show(bmscr[abms]->obj[id].wnd);
	bmscr[abms]->cury+=bmscr[abms]->objh;
	//bmscr[abms]->objs++;
	return 0;
}

int hs_input(){
	int id=find_nullobj();
	sval.stat=id;
	if(id<0)
		return 0;
	bmscr[abms]->obj[id].dat = prmm[0].i;
	bmscr[abms]->obj[id].style = 12;
	bmscr[abms]->obj[id].wnd = gtk_entry_new();
	//gtk_entry_set_max_length(,200);
	gtk_widget_set_usize(bmscr[abms]->obj[id].wnd,bmscr[abms]->objw,bmscr[abms]->objh);
	gtk_entry_set_text((GtkEntry*)bmscr[abms]->obj[id].wnd,prmm[0].pStr);

	gtk_editable_set_editable((GtkEditable*)bmscr[abms]->obj[id].wnd,true);

	gtk_signal_connect(GTK_OBJECT(bmscr[abms]->obj[id].wnd),"changed",
			GTK_SIGNAL_FUNC(object_event),(gpointer)(id+(abms<<16)));
	gtk_signal_connect(GTK_OBJECT(bmscr[abms]->obj[id].wnd),"focus_in_event",
			GTK_SIGNAL_FUNC(object_focus),(gpointer)(id+(abms<<16)));

	gtk_fixed_put(GTK_FIXED (bmscr[abms]->fixed),bmscr[abms]->obj[id].wnd,
		bmscr[abms]->curx, bmscr[abms]->cury);
	gtk_widget_show(bmscr[abms]->obj[id].wnd);
	bmscr[abms]->cury+=bmscr[abms]->objh;
	//bmscr[abms]->objs++;
	return 0;
}


int hs_mesbox(){
	int id=find_nullobj();
	sval.stat=id;
	if(id<0)
		return 0;
	int x,y,f;
	if(prms>1)
		x=prmm[1].i;
	else
		x=bmscr[abms]->objw;
	if(prms>2)
		y=prmm[2].i;
	else
		y=bmscr[abms]->objh;

	if(prms>3)
		f=prmm[3].i!=0;
	else
		f=0;

	bmscr[abms]->obj[id].dat = prmm[0].i;
	bmscr[abms]->obj[id].style = 12;
	bmscr[abms]->obj[id].wnd = gtk_text_new(NULL,NULL);
	gtk_widget_set_usize(bmscr[abms]->obj[id].wnd,x,y);
	char *s =  prmm[0].pStr;
	int i=0;
	gtk_editable_insert_text((GtkEditable*)bmscr[abms]->obj[id].wnd,
		s,strlen(s),&i);
	gtk_text_set_editable((GtkText*)bmscr[abms]->obj[id].wnd,f);

	gtk_signal_connect(GTK_OBJECT(bmscr[abms]->obj[id].wnd),"changed",
			GTK_SIGNAL_FUNC(object_event),(gpointer)(id+(abms<<16)));
	gtk_signal_connect(GTK_OBJECT(bmscr[abms]->obj[id].wnd),"focus_in_event",
			GTK_SIGNAL_FUNC(object_focus),(gpointer)(id+(abms<<16)));

	gtk_fixed_put(GTK_FIXED (bmscr[abms]->fixed),bmscr[abms]->obj[id].wnd,
		bmscr[abms]->curx, bmscr[abms]->cury);
	gtk_widget_show(bmscr[abms]->obj[id].wnd);
	bmscr[abms]->cury+=bmscr[abms]->objh;
	//bmscr[abms]->objs++;
	return 0;
}
int getline(char *s,char *buf,int *p){
	buf+=*p;
	int i=0;
	while(buf[i]){
		if(buf[i]==13 || buf[i]==10){
			*p+=(buf[i]==13 && buf[i+1]==10) +1;
			break;
		}
		if(i<1024)s[i]=buf[i];
		i++;
	}
	s[i]=0;
	*p+=i;
	return i;
}

int hs_listbox(){
	int id=find_nullobj();
	sval.stat=id;
	if(id<0)
		return 0;
	int x,y;
	if(prms>2)
		x=prmm[2].i;
	else
		x=bmscr[abms]->objw;
	if(prms>3)
		y=prmm[3].i;
	else
		y=bmscr[abms]->objh;


	GtkWidget *list,*item;
	char s[1024];
	list=gtk_list_new();
	bmscr[abms]->obj[id].dat = prmm[0].i;
	bmscr[abms]->obj[id].wnd = gtk_scrolled_window_new(NULL,NULL);
	gtk_widget_set_usize(bmscr[abms]->obj[id].wnd,x,y);
	gtk_scrolled_window_set_policy((GtkScrolledWindow*)bmscr[abms]->obj[id].wnd,
			GTK_POLICY_NEVER,GTK_POLICY_AUTOMATIC);
	//gtk_container_add(GTK_CONTAINER(bmscr[abms]->obj[id].wnd),list);
	gtk_scrolled_window_add_with_viewport((GtkScrolledWindow*)bmscr[abms]->obj[id].wnd,list);

	bmscr[abms]->obj[id].style = 13;
	gtk_list_set_selection_mode(GTK_LIST(list),GTK_SELECTION_BROWSE);
	int i,p=0;
	for (i=0;getline(s,prmm[1].s,&p);i++) {
		//printf("%s\n",s);
		item=gtk_list_item_new_with_label(s);
		gtk_signal_connect(GTK_OBJECT(item),"select",
				GTK_SIGNAL_FUNC(object_event),(gpointer)(id+(abms<<16)));
		//gtk_signal_connect(GTK_OBJECT(item),"deselect",
		//		GTK_SIGNAL_FUNC(object_event),(gpointer)(id+(abms<<16)));
		gtk_container_add(GTK_CONTAINER(list),item);
		gtk_widget_show(item);
	}
	gtk_signal_connect(GTK_OBJECT(bmscr[abms]->obj[id].wnd),"focus_in_event",
			GTK_SIGNAL_FUNC(object_focus),(gpointer)(id+(abms<<16)));
	gtk_widget_show(list);
	gtk_fixed_put(GTK_FIXED(bmscr[abms]->fixed),bmscr[abms]->obj[id].wnd,
		bmscr[abms]->curx, bmscr[abms]->cury);
	gtk_widget_show(bmscr[abms]->obj[id].wnd);
	bmscr[abms]->cury+=bmscr[abms]->objh;
	//bmscr[abms]->objs++;
	return 0;
}

int hs_combox(){
	int id=find_nullobj();
	sval.stat=id;
	if(id<0)
		return 0;
	int x,y;
	if(prms>2)
		x=prmm[2].i;
	else
		x=bmscr[abms]->objw;
	if(prms>3)
		y=prmm[3].i;
	else
		y=bmscr[abms]->objh;


	GtkWidget *cmb,*item;
	char s[1024];
	cmb=gtk_combo_new();
	bmscr[abms]->obj[id].dat = prmm[0].i;
	bmscr[abms]->obj[id].wnd = cmb;
	gtk_widget_set_usize(bmscr[abms]->obj[id].wnd,x,y);

	bmscr[abms]->obj[id].style = 13;
	gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(cmb)->entry),FALSE);
	gtk_list_set_selection_mode(GTK_LIST(GTK_COMBO(cmb)->list),GTK_SELECTION_BROWSE);
	int i,p=0;
	for (i=0;getline(s,prmm[1].s,&p);i++) {
		item=gtk_list_item_new_with_label(s);
		gtk_signal_connect(GTK_OBJECT(item),"select",
				GTK_SIGNAL_FUNC(object_event),(gpointer)(id+(abms<<16)));
		gtk_container_add(GTK_CONTAINER(GTK_COMBO(cmb)->list),item);
		gtk_widget_show(item);
	}
	gtk_signal_connect(GTK_OBJECT(bmscr[abms]->obj[id].wnd),"focus_in_event",
			GTK_SIGNAL_FUNC(object_focus),(gpointer)(id+(abms<<16)));
	gtk_widget_show(cmb);
	gtk_fixed_put(GTK_FIXED(bmscr[abms]->fixed),bmscr[abms]->obj[id].wnd,
		bmscr[abms]->curx, bmscr[abms]->cury);
	bmscr[abms]->cury+=bmscr[abms]->objh;
	//bmscr[abms]->objs++;
	return 0;
}

//////////////////////////////////////////////////////////////////
//	screen ̿
//

int hs_screen(){
	if(bmscr[prmm[0].i]){
		HSP_FreeBMS(bmscr[prmm[0].i]);
		//free(bmscr[prmm[0].i]);
	}else{
		bmscr[prmm[0].i]=(BMSCR*)malloc(sizeof(BMSCR));
	}
	HSP_InitBMS(bmscr[prmm[0].i],prmm[1].i,prmm[2].i,0);
	abms=prmm[0].i;
	gtk_widget_set_uposition(bmscr[abms]->wnd,prmm[4].i,prmm[5].i);
	if(prmm[3].type!=1 || (prmm[3].i&2)==0){
		gtk_widget_show(bmscr[abms]->wnd);
		WaitInitBMS(bmscr[abms]);
	}
	return 0;
}

int hs_bgscr(){
	if(bmscr[prmm[0].i]){
		HSP_FreeBMS(bmscr[prmm[0].i]);
		//free(bmscr[prmm[0].i]);
	}else{
		bmscr[prmm[0].i]=(BMSCR*)malloc(sizeof(BMSCR));
	}
	HSP_InitBMS(bmscr[prmm[0].i],prmm[1].i,prmm[2].i,1024);
	abms=prmm[0].i;
	gtk_widget_set_uposition(bmscr[abms]->wnd,prmm[4].i,prmm[5].i);
	if(prmm[3].type!=1 || (prmm[3].i&2)==0){
		gtk_widget_show(bmscr[abms]->wnd);
		WaitInitBMS(bmscr[abms]);
	}
	return 0;
}

int hs_buffer(){
	if(bmscr[prmm[0].i]){
		HSP_FreeBMS(bmscr[prmm[0].i]);
		//free(bmscr[prmm[0].i]);
	}else{
		bmscr[prmm[0].i]=(BMSCR*)malloc(sizeof(BMSCR));
	}
	HSP_InitBMS2(bmscr[prmm[0].i],prmm[1].i,prmm[2].i,0);
	abms=prmm[0].i;
	return 0;
}

//////////////////////////////////////////////////////////////////
//	gsel ̿
//

int hs_gsel(){
	if(bmscr[prmm[0].i]){
		abms=prmm[0].i;
	}
	if(prms>1){
		if(prmm[1].i<0)
			gtk_widget_hide(bmscr[abms]->wnd);
		if(prmm[1].i==1)
			gtk_widget_show(bmscr[abms]->wnd);
		if(prmm[1].i==2)
			gtk_widget_show(bmscr[abms]->wnd);
	}
	WaitInitBMS(bmscr[abms]);
	return 0;
}


//////////////////////////////////////////////////////////////////
//	dialog ̿Ϣ
//

void hsdialog_mb_ok(GtkWidget *widget,GtkDialog *dlg){
	sval.stat=1;
	gtk_widget_destroy(GTK_WIDGET(dlg));
	gtk_main_quit();
}

void hsdialog_mb_yes(GtkWidget *widget,GtkWidget *dlg){
	sval.stat=6;
	gtk_widget_destroy(GTK_WIDGET(dlg));
	gtk_main_quit();
}

void hsdialog_mb_no(GtkWidget *widget,GtkWidget *dlg){
	sval.stat=7;
	gtk_widget_destroy(GTK_WIDGET(dlg));
	gtk_main_quit();
}



void hsdialog_dlg_cancel(GtkWidget *widget,GtkWidget *dlg){
	sval.stat=0;
	gtk_widget_destroy(GTK_WIDGET(dlg));
	gtk_main_quit();
}
void hsdialog_dlg_destroy(GtkWidget *widget,GtkWidget *dlg){
	sval.stat=0;
	gtk_main_quit();
}

void hsdialog_file_ok(GtkWidget *widget, GtkFileSelection *fsel){
	sval.stat=1;
	gchar* f=gtk_file_selection_get_filename(GTK_FILE_SELECTION(fsel));
	strcpy(sval.refstr,f);
	gtk_widget_destroy(GTK_WIDGET(fsel));
	gtk_main_quit();
}

void hsdialog_color_ok(GtkWidget *widget,GtkWidget *dlg){
	sval.stat=1;
	gdouble color[3];
	GtkWidget *csel;
	csel=GTK_COLOR_SELECTION_DIALOG(dlg)->colorsel;
	GdkColormap *cmap;
	cmap = gdk_window_get_colormap(bmscr[abms]->wnd->window);
	gtk_color_selection_get_color(GTK_COLOR_SELECTION(csel),color);
	sval.rval=(int)(color[0]*255.0);
	sval.gval=(int)(color[1]*255.0);
	sval.bval=(int)(color[2]*255.0);
	gtk_widget_destroy(GTK_WIDGET(dlg));
	gtk_main_quit();
}

int hs_dialog(){
	if(prmm[1].i<4){
		sval.stat=0;
		GtkWidget *dlg,*label,*button;
		dlg=gtk_dialog_new();
		gtk_window_set_default_size(GTK_WINDOW(dlg),200,120);
		gtk_signal_connect(GTK_OBJECT(dlg), "destroy",
			(GtkSignalFunc) hsdialog_dlg_destroy, dlg);
		if(prms>2)
			gtk_window_set_title(GTK_WINDOW(dlg),prmm[2].s);
		//
		label=gtk_label_new(prmm[0].s);
		gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dlg)->vbox),label,TRUE,TRUE,0);
		gtk_widget_show (label);
		//
		if(prmm[1].i<2){
			button=gtk_button_new_with_label("OK");
			gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dlg)->action_area),button,TRUE,TRUE,0);
			gtk_signal_connect(GTK_OBJECT(button),
				"clicked", (GtkSignalFunc) hsdialog_mb_ok, dlg);
			gtk_widget_show (button);
		}else{
			button=gtk_button_new_with_label("YES");
			gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dlg)->action_area),button,TRUE,TRUE,0);
			gtk_signal_connect(GTK_OBJECT(button),
				"clicked", (GtkSignalFunc) hsdialog_mb_yes, dlg);
			gtk_widget_show (button);
			button=gtk_button_new_with_label("NO");
			gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dlg)->action_area),button,TRUE,TRUE,0);
			gtk_signal_connect(GTK_OBJECT(button),
				"clicked", (GtkSignalFunc) hsdialog_mb_no, dlg);
			gtk_widget_show (button);
		}
		//
		gtk_window_set_position(GTK_WINDOW(dlg),GTK_WIN_POS_CENTER);
		gtk_widget_show(dlg);
		//gtk_window_set_modal(GTK_WINDOW(dlg),FALSE);
		gtk_grab_add(dlg);
		gtk_main();
	}else if(prmm[1].i==16 || prmm[1].i==17){
		GtkWidget *fsel;
		fsel=gtk_file_selection_new (prmm[2].s);
		sval.stat=0;
		gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(fsel)->ok_button),
			"clicked", (GtkSignalFunc) hsdialog_file_ok, fsel);
		gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION (fsel)->cancel_button),
			"clicked", (GtkSignalFunc) hsdialog_dlg_cancel, fsel);
		gtk_signal_connect(GTK_OBJECT(fsel), "destroy",
			(GtkSignalFunc) hsdialog_dlg_destroy, fsel);
		gtk_widget_show(fsel);
		gtk_grab_add(GTK_WIDGET(fsel));
		gtk_main();
	}else if(prmm[1].i==32 || prmm[1].i==33){
		GtkWidget *dlg;
		sval.stat=0;
		dlg=gtk_color_selection_dialog_new("Select color");
		//gtk_signal_connect(GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG(dlg)->colorsel),
		//	"color_changed", (GtkSignalFunc) hsdialog_change, dlg);
		gtk_signal_connect(GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG(dlg)->ok_button),
			"clicked", (GtkSignalFunc) hsdialog_color_ok, dlg);
		gtk_signal_connect(GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG(dlg)->cancel_button),
			"clicked", (GtkSignalFunc) hsdialog_dlg_cancel, dlg);
		gtk_signal_connect(GTK_OBJECT(dlg), "destroy",
			(GtkSignalFunc) hsdialog_dlg_destroy, dlg);
		gtk_widget_hide(GTK_COLOR_SELECTION_DIALOG(dlg)->help_button);
		gtk_widget_show(dlg);
		gtk_grab_add(GTK_WIDGET(dlg));
		gtk_main();
	}
	return 0;
}

//////////////////////////////////////////////////////////////////
//
//

void gui_getWinsize(int *x,int *y)
{
	*x=bmscr[abms]->sx;
	*y=bmscr[abms]->sy;
}

void gui_getCurrentPos(int *x,int *y)
{
        *x=bmscr[abms]->curx;
        *y=bmscr[abms]->cury;
}

void gui_getPointer(int *x,int *y)
{
	gdk_window_get_pointer(bmscr[abms]->wnd->window,x,y,NULL);
}

int excmd_list(FUNCINFO* hs_func,int size)
{
	hs_func[0x10].func=hs_wait;
	hs_func[0x10].ptyp=0x00001;
	hs_func[0x13].func=hs_mes;
	hs_func[0x13].ptyp=0x00000;

	hs_func[0x1a].func=hs_stop;
	hs_func[0x1a].ptyp=0x00000;

	hs_func[0x21].func=hs_await;
	hs_func[0x21].ptyp=0x00001;
	//0x48xx
	hs_func[0x00|0x80].func=hs_button;
	hs_func[0x00|0x80].ptyp=0x00012;
	hs_func[0x10|0x80].func=hs_title;
	hs_func[0x10|0x80].ptyp=0x00012;
	hs_func[0x11|0x80].func=hs_pos;
	hs_func[0x11|0x80].ptyp=0x00011;
	hs_func[0x13|0x80].func=hs_cls;
	hs_func[0x13|0x80].ptyp=0x00011;
	hs_func[0x14|0x80].func=hs_font;
	hs_func[0x14|0x80].ptyp=0x00012;
	hs_func[0x15|0x80].func=hs_sysfont;
	hs_func[0x15|0x80].ptyp=0x00000;
	hs_func[0x16|0x80].func=hs_objsize;
	hs_func[0x16|0x80].ptyp=0x00011;
	hs_func[0x17|0x80].func=hs_picload;
	hs_func[0x17|0x80].ptyp=0x01112;
	hs_func[0x18|0x80].func=hs_color;
	hs_func[0x18|0x80].ptyp=0x00111;
	hs_func[0x1b|0x80].func=hs_redraw;
	hs_func[0x1b|0x80].ptyp=0x11111;
	hs_func[0x1c|0x80].func=hs_width;
	hs_func[0x1c|0x80].ptyp=0x01111;
	hs_func[0x1d|0x80].func=hs_gsel;
	hs_func[0x1d|0x80].ptyp=0x00111;
	hs_func[0x1e|0x80].func=hs_gcopy;
	hs_func[0x1e|0x80].ptyp=0x11111;
	hs_func[0x1f|0x80].func=hs_gzoom;
	hs_func[0x1f|0x80].ptyp=0x1111111;
	hs_func[0x20|0x80].func=hs_gmode;
	hs_func[0x20|0x80].ptyp=0x01111;
	hs_func[0x21|0x80].func=hs_bmpsave;
	hs_func[0x21|0x80].ptyp=0x00012;
	hs_func[0x23|0x80].func=hs_getkey;
	hs_func[0x23|0x80].ptyp=0x00119;
	hs_func[0x27|0x80].func=hs_input;
	hs_func[0x27|0x80].ptyp=0x01118;
	hs_func[0x28|0x80].func=hs_mesbox;
	hs_func[0x28|0x80].ptyp=0x01118;
	hs_func[0x29|0x80].func=hs_buffer;
	hs_func[0x29|0x80].ptyp=0x11111;
	hs_func[0x2a|0x80].func=hs_screen;
	hs_func[0x2a|0x80].ptyp=0x11111;
	hs_func[0x2b|0x80].func=hs_bgscr;
	hs_func[0x2b|0x80].ptyp=0x11111;
	hs_func[0x2c|0x80].func=hs_dialog;
	hs_func[0x2c|0x80].ptyp=0x00212;

	hs_func[0x31|0x80].func=hs_boxf;
	hs_func[0x31|0x80].ptyp=0x01111;
	hs_func[0x32|0x80].func=hs_pget;
	hs_func[0x32|0x80].ptyp=0x00011;
	hs_func[0x33|0x80].func=hs_pset;
	hs_func[0x33|0x80].ptyp=0x00011;

	hs_func[0x39|0x80].func=hs_clrobj;
	hs_func[0x39|0x80].ptyp=0x00011;
	hs_func[0x3a|0x80].func=hs_chkbox;
	hs_func[0x3a|0x80].ptyp=0x00032;
	hs_func[0x3b|0x80].func=hs_line;
	hs_func[0x3b|0x80].ptyp=0x01111;
	hs_func[0x3c|0x80].func=hs_stick;
	hs_func[0x3c|0x80].ptyp=0x00119;
	hs_func[0x3e|0x80].func=hs_combox;
	hs_func[0x3e|0x80].ptyp=0x01128;

	hs_func[0x40|0x80].func=hs_objprm;
	hs_func[0x40|0x80].ptyp=0x00001;
	hs_func[0x4b|0x80].func=hs_listbox;
	hs_func[0x4b|0x80].ptyp=0x01129;
	hs_func[0x4c|0x80].func=hs_objsel;
	hs_func[0x4c|0x80].ptyp=0x00001;
	return 0;
}


