

struct PVAL{ //PVAL2ɤ
	short type;
	short mode;
	int dsize[5];
	int size;
	union{
		char	*pt;
		unsigned char* pStr;
		int* pInt;
	};
};

// ѥ᡼
#define PRM_NONE -1
#define PRM_INT 0x1
#define PRM_STR 0x2
#define PRM_VAL 0x3
//#define PRM_LBL 0x4
#define PRM_PTR 0x8
#define PRM_PINT (PRM_PTR | PRM_INT)
#define PRM_PSTR (PRM_PTR | PRM_STR)

struct PARAM {
	int type;
	int mode;
	int mode2;
	union{
		int i;
		char *pStr;
		int *pInt;
	};
	int p;
	char s[1024];
};

struct SYSTEMVAL{
	int stat;
	int strsize;
	int looplev;
	int sublev;
	int mousex,mousey;
	int rval,gval,bval;
	int iparam,wparam,lparam;
	char refstr[512];
	char curdir[512];
	char cmdline[512];

	char mbutton[4];
	char keystat[256];
};

struct LOOPINFO{
	int cnt; //count
	int ed;  // end
	int spt; //repeat
	int ept; // loop
};

struct MODINFO{
	int num;
	unsigned short type;
	short prms;
	int name;
	int pt;
};

struct HSP_INFO{
	unsigned char* buf;
	unsigned short* code;
	int size;
	unsigned char* str;
	int* label;
	MODINFO* modlist;
	int vcnt;
	int pt;
	int eventflag;
	int fskiperr;
	PVAL *vallist;
	LOOPINFO loop[32];
	int onexit,onclick,onkey,onerror;
};

struct FUNCINFO{
	int (*func)();
	int ptyp;
};

#ifdef HSPDBG
static char *err[]={
	"Unknown code",                                 // 1
	"Syntax error",                                 // 2
	"Illegal function call",                        // 3
	"Wrong expression",                             // 4
	"No default parameter",                         // 5
	"Type mismatch",                                // 6
	"Array overflow",                               // 7
	"Not a label object",                           // 8
	"Too many nesting",                             // 9
	"Return without gosub",                         // 10
	"Loop without repeat",                          // 11
	"File I/O error",                               // 12
	"Picture file missing",                         // 13
	"External execute error",                       // 14
	"Priority error",                               // 15
	"Too many parameters",                          // 16
	"Temporary buffer overflow",                    // 17
	"Wrong valiable name",                          // 18
	"Divided by zero",                              // 19
	"Buffer Overflow",                              // 20
	"*"
};
#endif

void dpm_set(char*file, long offset);
int  dpm_exist(char *lpFile);
bool dpm_load(void*buf,int size,char *lpFile,int offset);
FILE* hsp_fopen(char *lpFile,long *size);
int hsp_fclose(FILE *fp);

bool bsave(void *buf, int size, char *lpFile);
bool bsave2(void *buf, int size, char *lpFile,int offset);

int readval(int *dat,const unsigned short *code);

extern PARAM prmm[12];
extern PARAM modprm[8];
extern int prms;

extern SYSTEMVAL sval;
extern HSP_INFO hsinfo;

